﻿B4A=true
Group=Modules
ModulesStructureVersion=1
Type=StaticCode
Version=8.3
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
End Sub

'FONTAWESOME TO BITMAP
Sub FontAwesomeToBitmap(Text As String, FontSize As Float, FontColor As Int) As B4XBitmap 'Ignore
	Dim XUI As XUI
	Dim P As Panel = XUI.CreatePanel("")
		P.SetLayoutAnimated(0, 0, 0, 32dip, 32dip)
	Dim CVS1 As B4XCanvas
		CVS1.Initialize(p)
	Dim Fnt As B4XFont = XUI.CreateFont(Typeface.FONTAWESOME, FontSize)
	Dim R As B4XRect = CVS1.MeasureText(Text, Fnt)
	Dim BaseLine As Int = CVS1.TargetRect.CenterY - r.Height / 2 - r.Top
	CVS1.DrawText(Text, CVS1.TargetRect.CenterX, BaseLine, Fnt, FontColor, "CENTER")
	Dim B As B4XBitmap = CVS1.CreateBitmap
	CVS1.Release
	Return B
End Sub

'MATERIALICONS TO BITMAP
Sub MaterialIconsToBitmap(Text As String, FontSize As Float, FontColor As Int) As B4XBitmap 'Ignore
	Dim XUI As XUI
	Dim P As Panel = XUI.CreatePanel("")
		P.SetLayoutAnimated(0, 0, 0, 32dip, 32dip)
	Dim CVS1 As B4XCanvas
		CVS1.Initialize(p)
	Dim Fnt As B4XFont = XUI.CreateFont(Typeface.MATERIALICONS, FontSize)
	Dim R As B4XRect = CVS1.MeasureText(Text, Fnt)
	Dim BaseLine As Int = CVS1.TargetRect.CenterY - r.Height / 2 - r.Top
	CVS1.DrawText(Text, CVS1.TargetRect.CenterX, BaseLine, Fnt, FontColor, "CENTER")
	Dim B As B4XBitmap = CVS1.CreateBitmap
	CVS1.Release
	Return B
End Sub

'PROPER CASE TEXT
Sub ProperCase(Str As String) As String 'Ignore
	If Str.Length > 0 Then
		Dim X As String
		Dim J, K As Int

		X = Str.ToUpperCase.CharAt(0)
		Str = X & Str.SubString2(1, Str.Length)

		For J = 1 To Str.Length
			K = Str.IndexOf2(" ", J + 1)
			If k = -1 Then Exit
			X = Str.ToUpperCase.CharAt(K + 1)
			Str = Str.SubString2(0, K + 1) & X & Str.SubString2(K + 2, Str.Length)
		Next

	End If
	Return Str
End Sub

'GET ALL THE LABELS IN THE TABSTRIP HEADER
Sub GetAllTabLabels(TabStrip As TabStrip) As List
	Dim Jo As JavaObject = TabStrip
	Dim Ref As Reflector
		Ref.Target = Jo.GetField("tabStrip")
	Dim TC As Panel = Ref.GetField("tabsContainer")
	Dim Res As List
		Res.Initialize

	For Each V As View In TC
		If V Is Label Then Res.Add(V)
	Next
	Return Res
End Sub

'NINE PATCH BORDER
Sub NinePatch(Control As View, ImageName As String)  'Ignore
	Dim Package As String
	Dim Id As Int
	Dim Ref As Reflector

	Package = Ref.GetStaticField("anywheresoftware.b4a.BA", "packageName")
	Id = Ref.GetStaticField(Package & ".R$drawable", ImageName)
	Ref.Target = Ref.GetContext
	Ref.Target = Ref.RunMethod("getResources")
	Control.Background = Ref.RunMethod2("getDrawable", Id, "java.lang.int")
End Sub

'VALIDATE EMAIL ADDRESS FORMAT
Sub ValidateEmail(EmailAddress As String) As Boolean  'Ignore
	Dim MatchEmail As Matcher = Regex.Matcher("^(?i)[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])$", EmailAddress)
 
	If MatchEmail.Find = True Then
		Log(MatchEmail.Match)
		Return True
	Else
		Log("Oops, please double check your email address...")
		Return False
	End If
End Sub

'FILE PROVIDER FOR SHARING OF FILES TO OTHER APPS
Sub CreateFileProviderUri(Dir As String, FileName As String) As Object 'Ignore
	Dim FileProvider As JavaObject
		FileProvider.InitializeStatic("android.support.v4.content.FileProvider")
	Dim Context As JavaObject
		Context.InitializeContext
	Dim Fi As JavaObject
		Fi.InitializeNewInstance("java.io.File", Array(Dir, FileName))
	Return FileProvider.RunMethod("getUriForFile", Array(Context, Application.PackageName & ".provider", Fi))
End Sub

'Map the value from the 'From' range A and B to the 'To' range C and D.
Sub MapRange(Value As Float, FromLow As Float, FromHigh As Float, ToLow As Float, ToHigh As Float) As Float 'Ignore
	Return ToLow + (ToHigh - ToLow) * ((Value - FromLow) / (FromHigh - FromLow))
End Sub
